<template>
  <div>
    <q-card
      :id="`slide-id-${slide.id}`"
      flat
      bordered
      class="slide-card"
    >
      <q-btn
        outline
        style="color: black; float: right; margin: 5px"
        icon="delete"
        size="sm"
        dense
        @click="openDeletionDialog(slide)"
      >
        <q-tooltip
          anchor="top middle"
          self="bottom middle"
          :offset="[15, 15]"
        >
          Delete slide
        </q-tooltip>
      </q-btn>

      <q-btn
        outline
        style="color: black; float: right; margin-top: 5px;"
        icon="settings"
        size="sm"
        dense
        @click="openPreprocessingDialog(slide)"
        v-if="!hidePreprocessingControls()"
      >
        <q-tooltip
          anchor="top middle"
          self="bottom middle"
          :offset="[15, 15]"
        >
          Preprocess slide
        </q-tooltip>
      </q-btn>

      <q-item>
        <q-item-section>
          <q-item-label
            @click="copyToClipboard(slide.id)"
          >
            <q-tooltip
              anchor="top middle"
              self="bottom middle"
              :offset="[15, 15]"
            >
              EMPAIA ID : {{ slide.id }}<br>
              LOCAL ID &nbsp;&nbsp;: {{ slide.localId }} <br>
              LABEL &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;: {{ getLabel(slide, false) }}
            </q-tooltip>
            {{ getLabel(slide) }}
          </q-item-label>

          <q-item-label
            v-if="slide.info"
            caption
          >
            {{ getSlideExtension(slide) }}, {{ slide.info.extent.x }} x {{ slide.info.extent.y }}
          </q-item-label>
          <q-item-label
            v-else
            caption
          >
            {{ getSlideExtension(slide) }}
          </q-item-label>
        </q-item-section>
      </q-item>
      <div class="img-box">
        <img
          v-if="slide.thumbnail"
          class="img"
          :src="slide.thumbnail"
          @click="openSlideViewer(slide)"
        >
        <div
          v-else
        >
          <q-icon
            name="warning"
            color="red"
            size="4rem"
          >
            <q-tooltip
              anchor="top middle"
              self="bottom middle"
              :offset="[15, 15]"
            >
              Unable to open slide
            </q-tooltip>
          </q-icon>
        </div>
      </div>
      <q-list>
        <q-item>
          <q-item-section>
            <q-select
              v-model="slide.tissue"
              style="max-width: 220px"
              emit-value
              map-options
              use-input
              hide-selected
              fill-input
              input-debounce="0"
              outlined
              :options="filteredTissueOptions"
              label="Tissue"
              @filter="filterTissue"
              @input="updateSlide(slide)"
            >
              <template v-slot:prepend>
                <q-icon name="accessibility" />
              </template>
            </q-select>
          </q-item-section>
        </q-item>
        <q-item>
          <q-item-section>
            <q-select
              v-model="slide.stain"
              style="max-width: 220px"
              emit-value
              map-options
              use-input
              hide-selected
              fill-input
              input-debounce="0"
              outlined
              :options="filteredStainOptions"
              label="Stain"
              @filter="filterStain"
              @input="updateSlide(slide)"
            >
              <template v-slot:prepend>
                <q-icon name="format_color_fill" />
              </template>
            </q-select>
          </q-item-section>
        </q-item>
      </q-list>
    </q-card>
    <!-- DIALOG TO CONFIRM SLIDE DELETION -->
    <q-dialog
      v-model="confirmDeletion"
      persistent
    >
      <q-card>
        <q-card-section class="row items-center">
          <q-avatar
            icon="delete"
            color="red"
            text-color="white"
          />
          <span class="q-ml-md">Do you really want to delete slide <b>{{ getLabel(slide) }}</b>?</span>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn
            v-close-popup
            flat
            label="Cancel"
            color="primary"
          />
          <q-btn
            v-close-popup
            flat
            label="Confirm"
            color="red"
            @click="$emit('delete-slide')"
          />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- DIALOG TO CONFIRM SLIDE PREPROCESSING -->
    <q-dialog
      v-model="confirmPreprocessing"
      persistent
    >
      <q-card>
        <q-card-section class="row items-center">
          <q-avatar
            icon="settings"
            color="white"
            text-color="black"
          />
          <span class="q-ml-md">
            Do you want to request preprocessing for slide <b>{{ getLabel(slideForPreprocessing) }}</b>?
            <div
              v-if="!slideForPreprocessing.tissue||!slideForPreprocessing.stain"
              style="color: red"
            >
              <b>Preprocessing cannot be requested for this slide.<br>Please add the missing stain and tissue type first.</b>
            </div>
            <div
              v-if="existingPreprocessingRequests.length>0"
              style="color: red"
            >
              <b>Preprocessing for this slide has already been requested.<br>Request again only if the triggers have been updated recently.</b>
            </div>
          </span>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn
            v-close-popup
            flat
            label="Cancel"
            color="primary"
          />
          <q-btn
            v-close-popup
            flat
            label="Request Preprocessing"
            :disable="!slideForPreprocessing.tissue||!slideForPreprocessing.stain"
            @click="preprocessSlide"
          />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import mds from '../mixins/mds_api'
import getEnv from '../mixins/env'
import { debounce } from 'quasar'
import { supportedFormats } from '../mixins/file_formats'
import { getLabel } from '../mixins/slides'
import EventBus from '../mixins/event_bus'

export default {
  name: 'SlideCard',
  props: {
    slide: {
      type: Object,
      default: null
    },
    tissueOptions: {
      type: Array,
      default: function () {
        return []
      }
    },
    stainOptions: {
      type: Array,
      default: function () {
        return []
      }
    },
    creatorId: {
      type: String,
      default: 'default_user'
    }
  },
  data () {
    return {
      supportedFormats: supportedFormats,
      confirmDeletion: false,
      confirmPreprocessing: false,
      slideForPreprocessing: { localId: null },
      existingPreprocessingRequests: [],
      filteredTissueOptions: [],
      filteredStainOptions: []
    }
  },
  async created () {
    this.filteredTissueOptions = this.tissueOptions
    this.filteredStainOptions = this.stainOptions
    this.updateSlide = debounce(this.updateSlide, 500)
    this.getLabel = getLabel
  },
  methods: {
    getFileExtension (file) {
      if (file.name.includes('.ome.')) {
        return file.name.substring(file.name.lastIndexOf('.ome.') + 1)
      } else {
        return file.name.substring(file.name.lastIndexOf('.') + 1)
      }
    },
    async updateSlide (slide) {
      await mds.updateSlide(slide.id, slide.tissue, slide.stain)
      this.notifySlideUpdate(slide)
    },
    getSlideExtension (slide) {
      let extension = 'UNKNOWN'
      if (slide.storage) {
        const mainAddress = slide.storage.main_storage_address.path
        if (this.checkAddressFormatSupport(mainAddress)) {
          if (mainAddress.includes('.ome.')) {
            extension = mainAddress.substring(mainAddress.lastIndexOf('.ome.') + 1).toUpperCase()
          } else {
            extension = mainAddress.substring(mainAddress.lastIndexOf('.') + 1).toUpperCase()
          }
        } else {
          const linkedFileAddresses = slide.storage.secondary_storage_addresses
          if (linkedFileAddresses) {
            const firstLinkedFileAddress = linkedFileAddresses[0].address
            if (firstLinkedFileAddress) {
              extension = firstLinkedFileAddress.substring(firstLinkedFileAddress.lastIndexOf('.') + 1).toUpperCase()
            }
          }
        }
      }
      return extension
    },
    checkAddressFormatSupport (address) {
      return this.supportedFormats.filter(f => address.includes('.' + f)).length > 0
    },
    openSlideViewer(slide) {
      EventBus.$emit('open-slide-viewer', slide)
    },
    openDeletionDialog (slide) {
      this.slideForDeletion = slide
      this.confirmDeletion = true
    },
    async openPreprocessingDialog (slide) {
      this.slideForPreprocessing = slide
      this.confirmPreprocessing = true
      this.existingPreprocessingRequests = await this.getExistingPreprocessingRequestsForSlide(slide.id)
    },
    hidePreprocessingControls () {
      if (getEnv('DMC_DISABLE_PREPROCESSING_CONTROLS') === undefined) {
        return false
      }
      else {
        return getEnv('DMC_DISABLE_PREPROCESSING_CONTROLS') === 'true'
      }
    },
    async preprocessSlide () {
      await mds.createPreprocessingRequest(this.creatorId, this.slideForPreprocessing.id)
    },
    async getExistingPreprocessingRequestsForSlide (slideId) {
      const preprocessingRequests = await mds.queryPreprocessingRequests()
      return preprocessingRequests.items.filter(e => e.slide_id === slideId)
    },
    filterTissue (val, update) {
      update(
        () => {
          const needle = val.toLowerCase()
          this.filteredTissueOptions = this.tissueOptions.filter(v => v.label.toLowerCase().indexOf(needle) > -1)
        },
        ref => {
          if (val !== '' && ref.options.length > 0) {
            ref.setOptionIndex(-1)
            ref.moveOptionSelection(1, true)
          }
        }
      )
    },
    filterStain (val, update) {
      const needle = val.toLowerCase()
      this.filteredStainOptions = this.stainOptions.filter(v => v.label.toLowerCase().indexOf(needle) > -1)
      update(
        () => {
          const needle = val.toLowerCase()
          this.filteredStainOptions = this.stainOptions.filter(v => v.label.toLowerCase().indexOf(needle) > -1)
        },
        ref => {
          if (val !== '' && ref.options.length > 0) {
            ref.setOptionIndex(-1)
            ref.moveOptionSelection(1, true)
          }
        }
      )
    },
    notifySlideUpdate (slide) {
      this.$q.notify({
        color: 'green-4',
        textColor: 'white',
        icon: 'cloud_done',
        message: `Slide ${getLabel(slide)} updated`,
        timeout: 500
      })
    },
    copyToClipboard (text) {
      navigator.clipboard.writeText(text)
    }
  }
}
</script>

<style lang="sass" scoped>
.slide-card
  width: 250px
  height: 400px
.img-box
  height: 200px
  width: 248px
  display: flex
  justify-content: center
  align-items: center
.img
  max-width: 100%
  max-height: 100%
  display: block
  opacity: 1
.img:hover
  opacity: 0.4
  cursor: pointer
</style>
